'' =================================================================================================
''
''   File....... xbee_robot.spin
''   Purpose.... 
''   Author.....              
''   E-mail..... 
''   Started.... 
''   Updated.... 
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1   = 31                                                    ' programming/debug port
  TX1   = 30
  SDA   = 29
  SCL   = 28

  L_SVO = 13                                                    ' servos
  R_SVO = 12

  XBT   =  1                                                    ' xbee serial io
  XBR   =  0
  

con

  ' servo control values (microseconds)

  L_FWD  = 2_250
  L_STOP = 1_500
  L_REV  = 0_750

  R_FWD  = 0_750 
  R_STOP = 1_500
  R_REV  = 2_250 


obj

  xbee  : "xbee_object_2"
  servo : "jm_servo_8x"
 

var


pub main | c

  xbee.start(XBR, XBT, %0000, 9_600)                            ' start XBee coms 9600 baud
  servo.start(2, R_SVO)                                         ' use two servos
  pause(1000)

  xbee.at_init                                                  ' initialize xbee
  xbee.tx("1")                                                  ' indicate ready

  xbee.rxflush                                                  ' clear trash from xbee
  repeat
    c := xbee.rxtime(250)
    case c
      "f", "F":                                                 ' forward
        servo.set(0, R_FWD, 0)
        servo.set(1, L_FWD, 0)
        xbee.tx("F")

      "x", "X":                                                 ' stop
        servo.set(0, R_STOP, 0)
        servo.set(1, L_STOP, 0)
        xbee.tx("X")

      "b", "B":                                                 ' backward
        servo.set(0, R_REV, 0)
        servo.set(1, L_REV, 0)
        xbee.tx("B")
     
      "l", "L":                                                 ' left
        servo.set(0, R_FWD, 0)
        servo.set(1, L_STOP, 0)
        xbee.tx("L")  
  
      "r", "R":                                                 ' right
        servo.set(0, R_STOP, 0)
        servo.set(1, L_FWD, 0)
        xbee.tx("R") 


con

pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)
    

pub high(pin)

'' Makes pin output and high

  outa[pin] := 1
  dira[pin] := 1


pub low(pin)

'' Makes pin output and low

  outa[pin] := 0
  dira[pin] := 1


pub toggle(pin)

'' Toggles pin state

  !outa[pin]
  dira[pin] := 1


pub input(pin)

'' Makes pin input and returns current state

  dira[pin] := 0

  return ina[pin]


dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}